import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';

import { routes } from './store-init.routes';
import { StoreInitComponent } from './store-init.component';
import { InitStoreAuthGuard } from 'services';
import { MxDirectivesModule } from 'modules';


@NgModule({
  declarations: [
    // Components / Directives/ Pipes
    StoreInitComponent,
  ],
  imports: [
    CommonModule,
    FormsModule,
    MxDirectivesModule,
    RouterModule.forChild(routes),
  ],
  providers: [ InitStoreAuthGuard ]
})
export class StoreInitModule {
  public static routes = routes;
}
