import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';

import { DashboardLayoutModule, DashboardMenuModule,WinStoreSelectModule } from 'modules';

import { routes } from './report-store.routes';
import { ReportStoreComponent } from './report-store.component';
import { DashboardAuthGuard } from 'services';

@NgModule({
  declarations: [
    // Components / Directives/ Pipes
    ReportStoreComponent,
  ],
  imports: [
    CommonModule,
    FormsModule,
    DashboardLayoutModule,
    DashboardMenuModule,
    WinStoreSelectModule,
    RouterModule.forChild(routes),
  ],
  providers: [ DashboardAuthGuard ]
})
export class ReportStoreModule {
  public static routes = routes;
}
