import {
  Component,
  OnInit,
  OnDestroy
} from '@angular/core';
import {  Router, ActivatedRoute } from '@angular/router';
import * as _ from 'lodash';
import { CommonService, StoreService } from 'services';
import * as Swiper from 'swiper';

console.log('`Store init` component loaded asynchronously');

@Component({
  selector: 'report',
  templateUrl: './report.component.html',
  styles: [require('swiper/dist/css/swiper.css'), require('./report.component.scss')],
  providers: [CommonService, StoreService]
})
export class ReportComponent implements OnInit, OnDestroy {
  public slider: any;
  public menu = {
    show: false
  };

  constructor(private router: Router, private route: ActivatedRoute, private cs: CommonService, private ss: StoreService) {

  }

  public ngOnInit() {
    this.slider = new Swiper('.swiper-container', {
        slidesPerView: 1,
        direction: 'vertical',
        loop: true
    });
  }
  public ngOnDestroy() {
    this.slider = undefined;
  }

  /**
   * 前进到下一屏
   * 
   * 
   * @memberOf ReportComponent
   */
  public onGotoNextSlide() {
    this.slider && this.slider.slideNext();
  }

  /**
   * 显示主菜单
   * 
   * 
   * @memberOf ReportComponent
   */
  public onShowMenu() {
    this.menu.show = true;
  }

}
