import {
  Component,
  OnInit,
} from '@angular/core';
import {  Router, ActivatedRoute } from '@angular/router';
import * as _ from 'lodash';
import { CommonService, StoreService } from 'services';
import { UserApi, CommonApi, ShopApi, OrderApi,  User } from 'client';




const orderDefault = {
    id: '',
    orderNum: '',
    shopName: '',
    shopNum: '',
    money: '',
    needInvoice: 1,
    title: '',
    address: ''
};

@Component({
  selector: 'store-current',
  templateUrl: './store-current.component.html',
  styleUrls: ['./store-current.component.scss'],
  providers: [CommonService, StoreService, CommonApi, ShopApi, OrderApi, UserApi]
})
export class StoreCurrentComponent implements OnInit {

  public store: any = {
    id: '',
    address: '',
    provinceId: '',
    cityId: '',
    name: '',
    ownerName: '',
    phone: '',
    serviceIds: '',
    qrAddr: ''
  };
  
  
  public slider: any;
  public menu = {
    show: false
  };

  
  constructor(
    private router: Router,
    private route: ActivatedRoute,
    private cApi: CommonApi,
    private sApi: ShopApi,
    private oApi: OrderApi,
    private cs: CommonService,
    private ss: StoreService,
    private uApi: UserApi
  ) {

  }

  public ngOnInit() {
    let token = window.localStorage.getItem('token');
    let shopId = window.localStorage.getItem('shopId');
    if (!token || !shopId) {
      this.cs.gotoLoginPage(this.router);
      return;
    }
    this.sApi.defaultHeaders.set('token', token);
    this.getCurrentShop(shopId);
  }

  public getCurrentShop(id) {
    // this.sApi.shopShopIdGet(String(id)).subscribe((data) => {
    //   if (data.meta.code === 200) {
    //     this.store = Object.assign(this.store, data.data);
    //   } else {
    //     this.cs.responseErrorHandler(data, false, this.router);
    //   }
    // }, (err) => console.error(err));
  }



  /**
   * 显示主菜单
   * 
   * 
   * @memberOf ReportComponent
   */
  public onShowMenu() {
    this.menu.show = true;
  }



}
// {
//   "appId":"wx19aecd5f84a5a610",
//   "nonceStr":"2z2dhpmcmpd4fqns34jv2sb6kripqda4",
//   "package":"prepay_id=wx201702081107446b869c91c00891797716",
//   "signType":"MD5",
//   "timeStamp":"1486523264",
//   "paySign":"FB4C663C8E49F7F90608AF42C16B1D79"
// },