import {
  Component,
  OnInit,
  OnDestroy
} from '@angular/core';
import {  Router, ActivatedRoute } from '@angular/router';
import * as _ from 'lodash';
import { CommonService, StoreService } from 'services';
import { ShopApi, UserApi, MyShopResponseItem, UserAccountList } from 'client';


let users: UserAccountList[] = [
  {
    id: 1,
    name: '胡汉三',
    mobile: '13120998988',
    loginTime: '1487732028520',
    status: 1
  },
  {
    id: 2,
    name: '胡汉三',
    mobile: '13120998988',
    loginTime: '1487732028520',
    status: 2
  },
  {
    id: 3,
    name: '胡汉三',
    mobile: '13120998988',
    loginTime: '1487732028520',
    status: 1
  }
];

@Component({
  selector: 'sub-account-list',
  templateUrl: './list.component.html',
  styles: [require('./list.component.scss')],
  providers: [StoreService]
})
export class SubAccountListComponent implements OnInit, OnDestroy {
  public menu = {
    show: false
  };
  public listLoading: boolean = false;
  public lists: UserAccountList[] = [];
  private token: string = '';

  constructor(
    private router: Router,
    private route: ActivatedRoute,
    private cs: CommonService,
    private ss: StoreService,
    private sApi: ShopApi,
    private uApi: UserApi
  ) {

  }

  public ngOnInit() {
    this.token = localStorage.getItem('token');
    this.getMySubAccount();
  }
  public ngOnDestroy() {
  }


  /**
   * 显示主菜单
   * 
   * 
   * @memberOf ReportComponent
   */
  public onShowMenu() {
    this.menu.show = true;
  }

 
  /**
   * 编辑选中的账户
   * 
   * @param {any} item 
   * 
   * @memberOf SubAccountListComponent
   */
  public onEdit(item) {
    this.cs.gotoEditPage(this.router, 'subaccount', item.id);
  }


  /**
   * 添加新门店
   * 
   * 
   * @memberOf StoreListComponent
   */
  public onAddNewOne() {
    this.cs.gotoCreatePage(this.router, 'subaccount');
  }

  private getMySubAccount() {
    this.listLoading = true;
    this.uApi.userCarMobileAccountsGet().subscribe((data) => {
      if (data.meta.code === 200) {
        this.lists = data.data;
      }
    }, (err) => console.error(err), () => {
      this.listLoading = false;
    });
    // setTimeout(() => {
    //   // this.lists = [...users, ...users, ...users, ...users, ...users];
    //   let accounts = localStorage.getItem('test_account');
    //   this.lists = accounts ? JSON.parse(accounts) : [];
    //   this.listLoading = false;
    // }, 2000);
  }

}
