import { Component, OnInit } from '@angular/core';
import { CommonService, CommonDataService } from 'services';
import { UserApi } from 'client';
import {  Router, ActivatedRoute } from '@angular/router';

@Component({
  selector: 'dashboard',
  template: `
    <router-outlet></router-outlet>
  `,
})
export class DashboardComponent implements OnInit {
  constructor(private router: Router, private cs: CommonService, private cds: CommonDataService, private uApi: UserApi) {
  }
  public ngOnInit() {
    this.uApi.userUserInfoTokenGet(localStorage.getItem('token') || '').subscribe((data) => {
      if (data.meta.code === 200) {
        this.cds.userInfo = data.data;
      } else {
        this.cs.responseErrorHandler(data, true, this.router);
      }
    }, (err) => console.error(err));
  }

}
