import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';

import { routes } from './dashboard.routes';
import { DashboardComponent } from './dashboard.component';
import { DashboardAuthGuard } from 'services';


@NgModule({
  declarations: [
    // Components / Directives/ Pipes
    DashboardComponent,
  ],
  imports: [
    CommonModule,
    FormsModule,
    RouterModule.forChild(routes),
  ],
  providers: [ DashboardAuthGuard ]
})
export class DashboardModule {
  public static routes = routes;
}
