import {
  Component,
  OnInit,
  NgZone
} from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';

import { UserApi, CommonApi, User } from 'client';

// https://github.com/cotag/ts-md5
import { Md5 } from 'ts-md5/dist/md5';
// import { Cookie } from 'ng2-cookies';

@Component({
  selector: 'user-find-pwd',
  templateUrl: './find-pwd.component.html',
  styleUrls: ['./find-pwd.component.scss'],
  providers: [UserApi, CommonApi, Md5]
})

export class UserFindPwdComponent implements OnInit {
  public step: number = 1;
  public regForm: any = {
    mobile: '',
    code: '',
    captcha: '',
    password: '',
    registerChannal: 1,
    type: 2,
    protocol: true
  };
  public errorMsg: string = '';

  private submitting: boolean = false;
  private phone: string = '';
  private captcha: string = '';
  private rnd: string = '';

  public constructor(private router: Router, private uApi: UserApi, private cApi: CommonApi) {

  }

  public ngOnInit() {

  }

  private onCaptcha(evt) {
    this.captcha = evt;
  }
  private onSms(evt) {
    this.rnd = evt;
  }
  private onError(evt) {
    this.errorMsg = evt;
  }

  private onSave() {
    this.cApi.commonCodeVerifyGet(this.rnd, this.phone, localStorage.getItem('uuid')).subscribe((res) => {
      if (res.meta.code === 200) {
        this.router.navigate(['/user/find/pwd/set', res.data]);
      } else {
        this.errorMsg = res.error.message;
      }
    });
  }

}
