/*
 * Angular 2 decorators and services
 */
import {
  Component,
  OnInit,
  ViewEncapsulation
} from '@angular/core';
import { AppState } from './app.service';
import { PayApi, UserApi, ShopApi, OrderApi } from 'client';

/*
 * App Component
 * Top Level Component
 */
@Component({
  selector: 'app',
  encapsulation: ViewEncapsulation.None,
  styleUrls: [
    './app.component.css'
  ],
  template: `
    <div class="mx-app">
      <router-outlet></router-outlet>
    </div>
  `
})
export class AppComponent implements OnInit {
  public angularclassLogo = 'assets/img/angularclass-avatar.png';
  public name = 'Angular 2 Webpack Starter';
  public url = 'https://twitter.com/AngularClass';

  constructor(
    public appState: AppState,
    private pApi: PayApi,
    private uApi: UserApi,
    private sApi: ShopApi,
    private oApi: OrderApi
  ) {
    this.pApi['xiajj'] = 123;
    this.uApi.defaultHeaders.set('channel', 'carh5');
    this.pApi.defaultHeaders.set('channel', 'carh5');
    this.sApi.defaultHeaders.set('channel', 'carh5');
    this.oApi.defaultHeaders.set('channel', 'carh5');
  }

  public ngOnInit() {
    console.log('Initial App State', this.appState.state);
  }

}

/*
 * Please review the https://github.com/AngularClass/angular2-examples/ repo for
 * more angular app examples that you may copy/paste
 * (The examples may not be updated as quickly. Please open an issue on github for us to update it)
 * For help or questions please contact us at @AngularClass on twitter
 * or our chat on Slack at https://AngularClass.com/slack-join
 */
