import { Routes, RouterModule } from '@angular/router';
import { HomeComponent } from './home';
import { StoreorderComponent } from './storeorder';
import { AboutComponent } from './about';
import { NoContentComponent } from './no-content';



import { DataResolver } from './app.resolver';

export const ROUTES: Routes = [
  { path: '', redirectTo: 'home', pathMatch: 'full' },
  { path: 'home', component: HomeComponent },
  { path: 'storeorder', component: StoreorderComponent },
  { path: 'user', loadChildren: './+user#UserModule' },
  { path: 'account', loadChildren: './+account#AccountModule' },
  { path: 'dashboard', loadChildren: './+dashboard#DashboardModule' },
  { path: 'award', loadChildren: './+award#MxAwardModule' },
  { path: 'temp/page', loadChildren: './+temp-pages#MxTempPagesModule' },
  { path: 'activepwd', loadChildren: './+active-pwd#SubAccountActivePwdModule' },
  { path: '**', component: NoContentComponent }
];
