import { Component, OnInit } from '@angular/core';
import {  Router, ActivatedRoute, NavigationEnd } from '@angular/router';
import { UserApi, UserTokenVo } from 'client';
import { CommonService, CommonDataService } from 'services';
// import { Cookie } from 'ng2-cookies';

@Component({
    selector: 'dashboard-menu',
    templateUrl: './dashboard-menu.component.html',
    styleUrls: ['./dashboard-menu.component.scss']
})
export class DashboardMenuComponent implements OnInit {
    public isSub: UserTokenVo;
    constructor(private router: Router, private route: ActivatedRoute, private uApi: UserApi, private cs: CommonService, private cds: CommonDataService) {
    }

    public ngOnInit() {
        this.uApi.defaultHeaders.set('token', window.localStorage.getItem('token'));
        this.isSub = Number(localStorage.getItem('isSub'));
    }

    public onExit() {
        this.uApi.userLogoutPost().subscribe((data) => {
            if (data.meta && data.meta.code === 200) {
                this.cs.removeUserInfoFromLocalStorage();
                // Cookie.delete('token');
                this.router.navigate(['/user/login']);
            } else {
                this.cs.responseErrorHandler(data, false, this.router);
            }
        });
    }

    public showAlert() {
        alert('hehe');
    }
}
