import { Component, OnInit, Output, EventEmitter } from '@angular/core';
import { Router, ActivatedRoute, NavigationEnd } from '@angular/router';
import { CommonApi, UserApi } from 'client';
import { CommonService } from 'services';
// import { Cookie } from 'ng2-cookies';

@Component({
    selector: 'th-captcha',
    templateUrl: './th-captcha.component.html',
    styleUrls: ['./th-captcha.component.scss'],
    providers: [CommonApi, CommonService]
})

export class ThCaptchaComponent implements OnInit {
    @Output() public onInput: EventEmitter<any> = new EventEmitter();
    public img: string = '';
    public uuid: string = '';
    constructor(private router: Router, private route: ActivatedRoute, private uApi: UserApi, private cApi: CommonApi, private cs: CommonService) {

    }

    public ngOnInit() {
        this.onGetCodeImg();
    }

    /**
     * 生成图片验证码
     * 
     * 
     * @memberOf UserRegistComponent
     */
    public onGetCodeImg() {
        this.cApi.commonCaptchaBase64Post().subscribe((data) => {
            const resbody = data.json();
            if (resbody.meta.code === 200) {
                this.img = 'data:image/jpeg;base64,' + (resbody.data || '');
                this.uuid = data.headers.get('uuid');
                // this.uApi.defaultHeaders.set('uuid', data.headers.get('uuid'));
                localStorage.setItem('uuid', data.headers.get('uuid'));
            }
        });
    }

    public onChange(evt) {
        this.onInput.next(evt.target.value);
    }
    public onChangeCaptcha() {
        this.onGetCodeImg();
    }
}
