import { Component, Input, Output, OnInit, EventEmitter } from '@angular/core';
import { MyOrderData } from 'client';
import { StoreService } from 'services';
import * as moment from 'moment';

@Component({
    selector: 'win-order-detail',
    templateUrl: './win-order-detail.component.html',
    styleUrls: ['./win-order-detail.component.scss'],
    providers: [StoreService]
})
export class WinOrderDetailComponent implements OnInit {
    @Input() public order: MyOrderData;
    @Output() private onClose = new EventEmitter();
    constructor(public ss: StoreService) {
    }

    public ngOnInit() {

    }

    public onCancelHandler() {
        this.onClose.emit();
    }

    public moment(data, format) {
        return moment(data).format(format);
    }



}
