import { Component, Input, Output, OnInit, EventEmitter } from '@angular/core';
import { MxSubAccount, MxStoreResponseItem } from 'interfaces';

@Component({
    selector: 'win-store-select',
    templateUrl: './win-store-select.component.html',
    styleUrls: ['./win-store-select.component.scss']
})
export class WinStoreSelectComponent implements OnInit {
    public isStoreAll: boolean = false;
    @Input() public stores: MxStoreResponseItem[] = [];
    @Input() public show: boolean = false;
    @Output() private onOkey = new EventEmitter();
    @Output() private onCancel = new EventEmitter();
    constructor() {
    }

    public ngOnInit() {
        
    }

    public onWarnSelect(status) {
        status ? this.onOkey.emit() : this.onCancel.emit();
    }

    public onOkeyHandler() {
        this.onOkey.emit();
    }

    public onCancelHandler() {
        this.onCancel.emit();
    }

    public toggleCheckAll() {
        let current = this.checkedAll();
        this.stores.forEach((item) => {
            item.checked = current ? false : true;
        });
    }

    private checkedAll() {
        return this.stores.filter((item) => item.checked === false).length === 0;
    }

    



}
