import { Injectable } from '@angular/core';
import { CanActivate, Router, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
// import { Cookie } from 'ng2-cookies';

@Injectable()
export class DashboardAuthGuard implements CanActivate {
  constructor(private router: Router) {
  }

  public canActivate(route: ActivatedRouteSnapshot, state: RouterStateSnapshot) {
    console.log('--------------- dashboard AuthGuard -------------------');
    let token = localStorage.getItem('token');
    if (!token) {
      this.router.navigate([`/user/login`]);
      return false;
    }
    let isSub = localStorage.getItem('isSub');
    let subStatus = localStorage.getItem('subStatus');
    if (isSub !== '1') {
      let shopPay = localStorage.getItem('shopPay');
      if (shopPay !== '2') {
        this.router.navigate([`/account/store/init`]);
        return false;
      }
    } else {
      if (subStatus === '1') {
        this.router.navigate([`/activepwd`]);
        return false;
      }
    }

    return true;
  }

}
