import { Injectable }  from '@angular/core';
import * as consts from 'consts';
import * as _ from 'lodash';
import { MxSubAccount } from 'interfaces';
@Injectable()
export class SubAccountService {

    /**
     * 获取默认子账号值
     * 
     * @returns {MxSubAccount} 
     * 
     * @memberOf StoreService
     */
    public getDefaultSubAccountValue(): MxSubAccount {
        return _.cloneDeep(consts.SUB_ACCOUNT_DEFAULT);
    }
}
