import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/observable/of';
import { CommonDataService } from 'services';

@Injectable()
export class UserInfoResolver implements Resolve<any> {
    constructor(private cds: CommonDataService) {}
    public resolve(route: ActivatedRouteSnapshot, state: RouterStateSnapshot) {
        let info: any;
        if (this.cds.userInfo) {
            info = this.cds.userInfo;
        } else {
            info = localStorage.getItem('token_login_info');
        }
        return info;
    }
}
