/**
 * 天会智数微信模块 API
 * 前后端交互协议, 遵循以下约定:   1. 所有api都属于无状态接口   2. 除了/user/login,/_*_/sms,/user/register,/user/updatePwd接口，其他接口都要登录之后才能操作   3. 登录成功之后，后端每次都把tokenheader,回传服务端   4. 客户端请求参数分两种:       1. 以form方式提交，可以附带store、pageNumber、pageSize参数       2. 以json方式提交，务必附带store、pageNumber、pageSize属性，如果没有值，为null   5. 服务端返回统一的json， 格式如下:       {        meta:{         code: 状态码         link: 链接         limit: 每页多少条         total:  总共多少条         current: 当前页         method: 方法         parameters:          {            客户端的请求参数          startDate:开始时间          endDate:结束时间          ........:xxxx(请求参数都会在meta里面)                    },         store:          {           客户端专用，保存交互状态的对象         }        }        data:          {           保存的数据，可能是array, object          object          list<object>          jsonArray        }        error:{           code:xxxxx (子状态码)           message:xxxxx        }       }            6. 公共状态(meta->code)约定如下:              500:             服务端处理失败， 返回json中存在error, meta对象， 不一定存在data对象          200:             成功， 返回json中有meta， data对象， 不存在error对象          401:             认证失败，用户的token过期或者token错误， 客户端需要引导用户重新登录          403:             授权失败， 一般出现在用户访问没有权限的资源, 返回json中存在error, meta对象          400:             参数错误,  客户端提交的参数不正确, 返回json中存在error, meta对象                 7. error的子状态码， 开发人员可以自行约定              8. header头信息信息:1.token: token值, 2. channel: 值:2.1 carh5(汽后-H5),carpc(汽后-PC),bh5(大B-H5),bpc(大B-PC)   
 *
 * OpenAPI spec version: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class CommonApi {
    protected basePath = '/manageredirect/api/v1/manage';
    // protected basePath = '/api/v1/manage';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * 验证码，返回的是验证码图片的base64
     * 通过的验证码接口 
     */
    public commonCaptchaBase64Post(extraHttpRequestParams?: any): Observable<Response> {
        return this.commonCaptchaBase64PostWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response;
                }
            });
    }

    /**
     * 验证码，返回的是stream， 客户端直接在图片src引用api url
     * 通过的验证码接口 
     */
    public commonCaptchaPost(extraHttpRequestParams?: any): Observable<{}> {
        return this.commonCaptchaPostWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 验证图形验证码的有效性
     * 
     * @param uuid 访问验证码生成的uuid
     * @param code 验证码
     */
    public commonCaptchaValidateGet(uuid: string, code: string, extraHttpRequestParams?: any): Observable<models.CommonResponse> {
        return this.commonCaptchaValidateGetWithHttpInfo(uuid, code, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 找回密码，检验手机验证码有效性， 客户端在点下一步时候调用, 如果服务端返回200， 则json里个修改密码的凭证sign. 客户端需要将在/user/updatePwd接口用到sign 
     * 
     * @param code 手机验证码
     * @param phone 手机号
     * @param uuid 验证码接口返回的uuid
     */
    public commonCodeVerifyGet(code: string, phone: string, uuid: string, extraHttpRequestParams?: any): Observable<models.PasswordResponse> {
        return this.commonCodeVerifyGetWithHttpInfo(code, phone, uuid, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 获取所有的省份，直辖市
     * 获取所有的省份，直辖市 
     */
    public commonRegionProvinceGet(extraHttpRequestParams?: any): Observable<models.RegionProvinceListResponse> {
        return this.commonRegionProvinceGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 获取市，区
     * 根据省，直辖市ID获取所有市，区 
     * @param provinceId 省，直辖市id
     */
    public commonRegionProvinceIdCityGet(provinceId: number, extraHttpRequestParams?: any): Observable<models.RegionProvinceListResponse> {
        return this.commonRegionProvinceIdCityGetWithHttpInfo(provinceId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * 验证码，返回的是验证码图片的base64
     * 通过的验证码接口 
     */
    public commonCaptchaBase64PostWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/common/captchaBase64`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 验证码，返回的是stream， 客户端直接在图片src引用api url
     * 通过的验证码接口 
     */
    public commonCaptchaPostWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/common/captcha`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 验证图形验证码的有效性
     * 
     * @param uuid 访问验证码生成的uuid
     * @param code 验证码
     */
    public commonCaptchaValidateGetWithHttpInfo(uuid: string, code: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/common/captcha/validate`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'uuid' is not null or undefined
        if (uuid === null || uuid === undefined) {
            throw new Error('Required parameter uuid was null or undefined when calling commonCaptchaValidateGet.');
        }
        // verify required parameter 'code' is not null or undefined
        if (code === null || code === undefined) {
            throw new Error('Required parameter code was null or undefined when calling commonCaptchaValidateGet.');
        }
        if (code !== undefined) {
            queryParameters.set('code', <any>code);
        }

        headers.set('uuid', String(uuid));

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 找回密码，检验手机验证码有效性， 客户端在点下一步时候调用, 如果服务端返回200， 则json里个修改密码的凭证sign. 客户端需要将在/user/updatePwd接口用到sign 
     * 
     * @param code 手机验证码
     * @param phone 手机号
     * @param uuid 验证码接口返回的uuid
     */
    public commonCodeVerifyGetWithHttpInfo(code: string, phone: string, uuid: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/common/code/verify`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'code' is not null or undefined
        if (code === null || code === undefined) {
            throw new Error('Required parameter code was null or undefined when calling commonCodeVerifyGet.');
        }
        // verify required parameter 'phone' is not null or undefined
        if (phone === null || phone === undefined) {
            throw new Error('Required parameter phone was null or undefined when calling commonCodeVerifyGet.');
        }
        // verify required parameter 'uuid' is not null or undefined
        if (uuid === null || uuid === undefined) {
            throw new Error('Required parameter uuid was null or undefined when calling commonCodeVerifyGet.');
        }
        if (code !== undefined) {
            queryParameters.set('code', <any>code);
        }

        if (phone !== undefined) {
            queryParameters.set('phone', <any>phone);
        }

        headers.set('uuid', String(uuid));

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 获取所有的省份，直辖市
     * 获取所有的省份，直辖市 
     */
    public commonRegionProvinceGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/common/region/province`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 获取市，区
     * 根据省，直辖市ID获取所有市，区 
     * @param provinceId 省，直辖市id
     */
    public commonRegionProvinceIdCityGetWithHttpInfo(provinceId: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/common/region/${provinceId}/city`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'provinceId' is not null or undefined
        if (provinceId === null || provinceId === undefined) {
            throw new Error('Required parameter provinceId was null or undefined when calling commonRegionProvinceIdCityGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
