/**
 * 天会智数微信模块 API
 * 前后端交互协议, 遵循以下约定:   1. 所有api都属于无状态接口   2. 除了/user/login,/_*_/sms,/user/register,/user/updatePwd接口，其他接口都要登录之后才能操作   3. 登录成功之后，后端每次都把tokenheader,回传服务端   4. 客户端请求参数分两种:       1. 以form方式提交，可以附带store、pageNumber、pageSize参数       2. 以json方式提交，务必附带store、pageNumber、pageSize属性，如果没有值，为null   5. 服务端返回统一的json， 格式如下:       {        meta:{         code: 状态码         link: 链接         limit: 每页多少条         total:  总共多少条         current: 当前页         method: 方法         parameters:          {            客户端的请求参数          startDate:开始时间          endDate:结束时间          ........:xxxx(请求参数都会在meta里面)                    },         store:          {           客户端专用，保存交互状态的对象         }        }        data:          {           保存的数据，可能是array, object          object          list<object>          jsonArray        }        error:{           code:xxxxx (子状态码)           message:xxxxx        }       }            6. 公共状态(meta->code)约定如下:              500:             服务端处理失败， 返回json中存在error, meta对象， 不一定存在data对象          200:             成功， 返回json中有meta， data对象， 不存在error对象          401:             认证失败，用户的token过期或者token错误， 客户端需要引导用户重新登录          403:             授权失败， 一般出现在用户访问没有权限的资源, 返回json中存在error, meta对象          400:             参数错误,  客户端提交的参数不正确, 返回json中存在error, meta对象                 7. error的子状态码， 开发人员可以自行约定              8. header头信息信息:1.token: token值, 2. channel: 值:2.1 carh5(汽后-H5),carpc(汽后-PC),bh5(大B-H5),bpc(大B-PC)   
 *
 * OpenAPI spec version: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class OrderApi {
    protected basePath = '/manageredirect/api/v1/manage';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * 逻辑删除订单  
     * 
     * @param id 订单id
     */
    public orderCarMobileIdDeleteDelete(id: string, extraHttpRequestParams?: any): Observable<models.OrderResponseEx> {
        return this.orderCarMobileIdDeleteDeleteWithHttpInfo(id, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 申请发票 
     * 
     * @param id 订单id
     * @param invoiceTitle 发票抬头
     * @param linkman 联系人
     * @param tel 联系电话
     */
    public orderCarMobileIdInvoicePost(id: number, invoiceTitle: string, linkman: string, tel: string, extraHttpRequestParams?: any): Observable<models.InvoiceResponse> {
        return this.orderCarMobileIdInvoicePostWithHttpInfo(id, invoiceTitle, linkman, tel, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 查询用户订单列表，用户凭证从http header读取 
     * 
     * @param token 用户登录token
     */
    public orderCarMobileListGet(token: string, extraHttpRequestParams?: any): Observable<models.MyOrderlistResponse> {
        return this.orderCarMobileListGetWithHttpInfo(token, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 查询订单信息 
     * 
     * @param orderId 订单基本信息
     */
    public orderCarMobileOrderIdGet(orderId: number, extraHttpRequestParams?: any): Observable<models.MyOrderResponse> {
        return this.orderCarMobileOrderIdGetWithHttpInfo(orderId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * 逻辑删除订单  
     * 
     * @param id 订单id
     */
    public orderCarMobileIdDeleteDeleteWithHttpInfo(id: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/order/carMobile/${id}/delete`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling orderCarMobileIdDeleteDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 申请发票 
     * 
     * @param id 订单id
     * @param invoiceTitle 发票抬头
     * @param linkman 联系人
     * @param tel 联系电话
     */
    public orderCarMobileIdInvoicePostWithHttpInfo(id: number, invoiceTitle: string, linkman: string, tel: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/order/carMobile/${id}/Invoice`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling orderCarMobileIdInvoicePost.');
        }
        // verify required parameter 'invoiceTitle' is not null or undefined
        if (invoiceTitle === null || invoiceTitle === undefined) {
            throw new Error('Required parameter invoiceTitle was null or undefined when calling orderCarMobileIdInvoicePost.');
        }
        // verify required parameter 'linkman' is not null or undefined
        if (linkman === null || linkman === undefined) {
            throw new Error('Required parameter linkman was null or undefined when calling orderCarMobileIdInvoicePost.');
        }
        // verify required parameter 'tel' is not null or undefined
        if (tel === null || tel === undefined) {
            throw new Error('Required parameter tel was null or undefined when calling orderCarMobileIdInvoicePost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/x-www-form-urlencoded');

        if (invoiceTitle !== undefined) {
            formParams.set('invoiceTitle', <any>invoiceTitle);
        }

        if (linkman !== undefined) {
            formParams.set('linkman', <any>linkman);
        }

        if (tel !== undefined) {
            formParams.set('tel', <any>tel);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 查询用户订单列表，用户凭证从http header读取 
     * 
     * @param token 用户登录token
     */
    public orderCarMobileListGetWithHttpInfo(token: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/order/carMobile/list`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'token' is not null or undefined
        if (token === null || token === undefined) {
            throw new Error('Required parameter token was null or undefined when calling orderCarMobileListGet.');
        }
        headers.set('token', String(token));

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 查询订单信息 
     * 
     * @param orderId 订单基本信息
     */
    public orderCarMobileOrderIdGetWithHttpInfo(orderId: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/order/carMobile/${orderId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'orderId' is not null or undefined
        if (orderId === null || orderId === undefined) {
            throw new Error('Required parameter orderId was null or undefined when calling orderCarMobileOrderIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
