/**
 * 天会智数微信模块 API
 * 前后端交互协议, 遵循以下约定:   1. 所有api都属于无状态接口   2. 除了/user/login,/_*_/sms,/user/register,/user/updatePwd接口，其他接口都要登录之后才能操作   3. 登录成功之后，后端每次都把tokenheader,回传服务端   4. 客户端请求参数分两种:       1. 以form方式提交，可以附带store、pageNumber、pageSize参数       2. 以json方式提交，务必附带store、pageNumber、pageSize属性，如果没有值，为null   5. 服务端返回统一的json， 格式如下:       {        meta:{         code: 状态码         link: 链接         limit: 每页多少条         total:  总共多少条         current: 当前页         method: 方法         parameters:          {            客户端的请求参数          startDate:开始时间          endDate:结束时间          ........:xxxx(请求参数都会在meta里面)                    },         store:          {           客户端专用，保存交互状态的对象         }        }        data:          {           保存的数据，可能是array, object          object          list<object>          jsonArray        }        error:{           code:xxxxx (子状态码)           message:xxxxx        }       }            6. 公共状态(meta->code)约定如下:              500:             服务端处理失败， 返回json中存在error, meta对象， 不一定存在data对象          200:             成功， 返回json中有meta， data对象， 不存在error对象          401:             认证失败，用户的token过期或者token错误， 客户端需要引导用户重新登录          403:             授权失败， 一般出现在用户访问没有权限的资源, 返回json中存在error, meta对象          400:             参数错误,  客户端提交的参数不正确, 返回json中存在error, meta对象                 7. error的子状态码， 开发人员可以自行约定              8. header头信息信息:1.token: token值, 2. channel: 值:2.1 carh5(汽后-H5),carpc(汽后-PC),bh5(大B-H5),bpc(大B-PC)   
 *
 * OpenAPI spec version: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class PayApi {
    protected basePath = '/manageredirect/api/v1/manage';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * 内网测试调用接口;支付完成修改订单相关信息;仅在关闭支付功能时使用; 
     * 
     * @param orderId 订单id
     * @param serviceType 系统内所属支付类型（1：门店年费服务，2...），目前只支持门店年费服务
     */
    public paymentPayTestPost(orderId: number, serviceType: number, extraHttpRequestParams?: any): Observable<string> {
        return this.paymentPayTestPostWithHttpInfo(orderId, serviceType, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 门店年费支付类型支付信息;
     * 
     * @param orderId 订单id
     */
    public paymentShopPayInfoPost(orderId: number, extraHttpRequestParams?: any): Observable<models.ShopPayInfoResponse> {
        return this.paymentShopPayInfoPostWithHttpInfo(orderId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 微信公众号方式的支付接口; 
     * 
     * @param orderId 订单id
     * @param openId 微信用户的openId
     * @param serviceType 系统内所属支付类型（1：门店年费服务，2...），目前只支持门店年费服务
     */
    public paymentWeChatPayPost(orderId: number, openId: string, serviceType: number, extraHttpRequestParams?: any): Observable<models.WeChatPayResponse> {
        return this.paymentWeChatPayPostWithHttpInfo(orderId, openId, serviceType, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 此接口为微信调用接口，前端无需调用;服务端根据微信传递的code获取openId; 服务端需解析state数据并做相应； state数据中含前端传递的url地址，后端需要在url中传递openId数据。 
     * 
     * @param code 微信传递参数，服务端根据微信传递的code获取openId
     * @param state 微信传递参数，此字段为自定义数据字段，前端可根据需要自行定义；
     */
    public weChatOpenIdGet(code: number, state: string, extraHttpRequestParams?: any): Observable<string> {
        return this.weChatOpenIdGetWithHttpInfo(code, state, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 获取code（此为服务端获取openId的必要参数）的url,前端获取后需请求此地址； 注意：state&#x3D;STATE为可自定数据字段；STATE约定格式为key1-value1@key2-value2@...;key1必须是url(服务器会redirect)，url需要URLEncode；STATE微信限定最大128字节； 
     * 
     */
    public weChatOpenIdURLGet(extraHttpRequestParams?: any): Observable<models.OpenIdURLResponse> {
        return this.weChatOpenIdURLGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * 内网测试调用接口;支付完成修改订单相关信息;仅在关闭支付功能时使用; 
     * 
     * @param orderId 订单id
     * @param serviceType 系统内所属支付类型（1：门店年费服务，2...），目前只支持门店年费服务
     */
    public paymentPayTestPostWithHttpInfo(orderId: number, serviceType: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/payment/payTest`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'orderId' is not null or undefined
        if (orderId === null || orderId === undefined) {
            throw new Error('Required parameter orderId was null or undefined when calling paymentPayTestPost.');
        }
        // verify required parameter 'serviceType' is not null or undefined
        if (serviceType === null || serviceType === undefined) {
            throw new Error('Required parameter serviceType was null or undefined when calling paymentPayTestPost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/x-www-form-urlencoded');

        if (orderId !== undefined) {
            formParams.set('orderId', <any>orderId);
        }

        if (serviceType !== undefined) {
            formParams.set('serviceType', <any>serviceType);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 门店年费支付类型支付信息;
     * 
     * @param orderId 订单id
     */
    public paymentShopPayInfoPostWithHttpInfo(orderId: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/payment/shop/payInfo`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'orderId' is not null or undefined
        if (orderId === null || orderId === undefined) {
            throw new Error('Required parameter orderId was null or undefined when calling paymentShopPayInfoPost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/x-www-form-urlencoded');

        if (orderId !== undefined) {
            formParams.set('orderId', <any>orderId);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 微信公众号方式的支付接口; 
     * 
     * @param orderId 订单id
     * @param openId 微信用户的openId
     * @param serviceType 系统内所属支付类型（1：门店年费服务，2...），目前只支持门店年费服务
     */
    public paymentWeChatPayPostWithHttpInfo(orderId: number, openId: string, serviceType: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/payment/weChatPay`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'orderId' is not null or undefined
        if (orderId === null || orderId === undefined) {
            throw new Error('Required parameter orderId was null or undefined when calling paymentWeChatPayPost.');
        }
        // verify required parameter 'openId' is not null or undefined
        if (openId === null || openId === undefined) {
            throw new Error('Required parameter openId was null or undefined when calling paymentWeChatPayPost.');
        }
        // verify required parameter 'serviceType' is not null or undefined
        if (serviceType === null || serviceType === undefined) {
            throw new Error('Required parameter serviceType was null or undefined when calling paymentWeChatPayPost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/x-www-form-urlencoded');

        if (orderId !== undefined) {
            formParams.set('orderId', <any>orderId);
        }

        if (openId !== undefined) {
            formParams.set('openId', <any>openId);
        }

        if (serviceType !== undefined) {
            formParams.set('serviceType', <any>serviceType);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 此接口为微信调用接口，前端无需调用;服务端根据微信传递的code获取openId; 服务端需解析state数据并做相应； state数据中含前端传递的url地址，后端需要在url中传递openId数据。 
     * 
     * @param code 微信传递参数，服务端根据微信传递的code获取openId
     * @param state 微信传递参数，此字段为自定义数据字段，前端可根据需要自行定义；
     */
    public weChatOpenIdGetWithHttpInfo(code: number, state: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/weChat/openId`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'code' is not null or undefined
        if (code === null || code === undefined) {
            throw new Error('Required parameter code was null or undefined when calling weChatOpenIdGet.');
        }
        // verify required parameter 'state' is not null or undefined
        if (state === null || state === undefined) {
            throw new Error('Required parameter state was null or undefined when calling weChatOpenIdGet.');
        }
        if (code !== undefined) {
            queryParameters.set('code', <any>code);
        }

        if (state !== undefined) {
            queryParameters.set('state', <any>state);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 获取code（此为服务端获取openId的必要参数）的url,前端获取后需请求此地址； 注意：state&#x3D;STATE为可自定数据字段；STATE约定格式为key1-value1@key2-value2@...;key1必须是url(服务器会redirect)，url需要URLEncode；STATE微信限定最大128字节； 
     * 
     */
    public weChatOpenIdURLGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/weChat/openIdURL`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
