/**
 * 天会智数微信模块 API
 * 前后端交互协议, 遵循以下约定:   1. 所有api都属于无状态接口   2. 除了/user/login,/_*_/sms,/user/register,/user/updatePwd接口，其他接口都要登录之后才能操作   3. 登录成功之后，后端每次都把tokenheader,回传服务端   4. 客户端请求参数分两种:       1. 以form方式提交，可以附带store、pageNumber、pageSize参数       2. 以json方式提交，务必附带store、pageNumber、pageSize属性，如果没有值，为null   5. 服务端返回统一的json， 格式如下:       {        meta:{         code: 状态码         link: 链接         limit: 每页多少条         total:  总共多少条         current: 当前页         method: 方法         parameters:          {            客户端的请求参数          startDate:开始时间          endDate:结束时间          ........:xxxx(请求参数都会在meta里面)                    },         store:          {           客户端专用，保存交互状态的对象         }        }        data:          {           保存的数据，可能是array, object          object          list<object>          jsonArray        }        error:{           code:xxxxx (子状态码)           message:xxxxx        }       }            6. 公共状态(meta->code)约定如下:              500:             服务端处理失败， 返回json中存在error, meta对象， 不一定存在data对象          200:             成功， 返回json中有meta， data对象， 不存在error对象          401:             认证失败，用户的token过期或者token错误， 客户端需要引导用户重新登录          403:             授权失败， 一般出现在用户访问没有权限的资源, 返回json中存在error, meta对象          400:             参数错误,  客户端提交的参数不正确, 返回json中存在error, meta对象                 7. error的子状态码， 开发人员可以自行约定              8. header头信息信息:1.token: token值, 2. channel: 值:2.1 carh5(汽后-H5),carpc(汽后-PC),bh5(大B-H5),bpc(大B-PC)   
 *
 * OpenAPI spec version: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class ShopApi {
    protected basePath = '/manageredirect/api/v1/manage';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * 批量创建门店 
     * 
     * @param payload 批量创建门店，json格式
     */
    public shopCarMobileBatchSavePost(payload: models.BatchSaveShopObj, extraHttpRequestParams?: any): Observable<models.BatchSaveShopResponse> {
        return this.shopCarMobileBatchSavePostWithHttpInfo(payload, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 逻辑删除门店        
     * 
     * @param id 门店id
     */
    public shopCarMobileDeleteDelete(id: number, extraHttpRequestParams?: any): Observable<models.DeleteShopResponse> {
        return this.shopCarMobileDeleteDeleteWithHttpInfo(id, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 获取注册后创建的第一家未支付的门店信息、订单信息、发票信息 
     * 
     * @param shopId 门店id
     */
    public shopCarMobileFirstShopInfoGet(shopId: number, extraHttpRequestParams?: any): Observable<models.FirstShopInfoResponse> {
        return this.shopCarMobileFirstShopInfoGetWithHttpInfo(shopId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 创建第一家门店,注册后会需要创建第一家门店；登录后如果没一家已支付的门店，也需要支付第一家门店； 
     * 
     * @param fistShop 第一家门店信息
     */
    public shopCarMobileFirstShopPost(fistShop: models.FirstShopData, extraHttpRequestParams?: any): Observable<models.FirstShopResponse> {
        return this.shopCarMobileFirstShopPostWithHttpInfo(fistShop, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 获取我们的门店列表，用户凭证从http header读取 
     * 
     * @param token 用户的登录凭证
     */
    public shopCarMobileMyshopGet(token: string, extraHttpRequestParams?: any): Observable<models.MyShopResponse> {
        return this.shopCarMobileMyshopGetWithHttpInfo(token, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 查询某个门店 
     * 
     * @param shopId 门店id
     */
    public shopCarMobileShopIdGet(shopId: number, extraHttpRequestParams?: any): Observable<models.SingleShopInfoResponse> {
        return this.shopCarMobileShopIdGetWithHttpInfo(shopId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 修改门店信息 
     * 
     * @param payload 更新的门店对象
     */
    public shopCarMobileUpdatePost(payload: models.UpdateShopInfoObj, extraHttpRequestParams?: any): Observable<models.UpdateShopResponse> {
        return this.shopCarMobileUpdatePostWithHttpInfo(payload, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * 批量创建门店 
     * 
     * @param payload 批量创建门店，json格式
     */
    public shopCarMobileBatchSavePostWithHttpInfo(payload: models.BatchSaveShopObj, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/shop/carMobile/batchSave`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'payload' is not null or undefined
        if (payload === null || payload === undefined) {
            throw new Error('Required parameter payload was null or undefined when calling shopCarMobileBatchSavePost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: payload == null ? '' : JSON.stringify(payload), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 逻辑删除门店        
     * 
     * @param id 门店id
     */
    public shopCarMobileDeleteDeleteWithHttpInfo(id: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/shop/carMobile/delete`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling shopCarMobileDeleteDelete.');
        }
        if (id !== undefined) {
            queryParameters.set('id', <any>id);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 获取注册后创建的第一家未支付的门店信息、订单信息、发票信息 
     * 
     * @param shopId 门店id
     */
    public shopCarMobileFirstShopInfoGetWithHttpInfo(shopId: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/shop/carMobile/firstShopInfo`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'shopId' is not null or undefined
        if (shopId === null || shopId === undefined) {
            throw new Error('Required parameter shopId was null or undefined when calling shopCarMobileFirstShopInfoGet.');
        }
        if (shopId !== undefined) {
            queryParameters.set('shopId', <any>shopId);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 创建第一家门店,注册后会需要创建第一家门店；登录后如果没一家已支付的门店，也需要支付第一家门店； 
     * 
     * @param fistShop 第一家门店信息
     */
    public shopCarMobileFirstShopPostWithHttpInfo(fistShop: models.FirstShopData, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/shop/carMobile/firstShop`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'fistShop' is not null or undefined
        if (fistShop === null || fistShop === undefined) {
            throw new Error('Required parameter fistShop was null or undefined when calling shopCarMobileFirstShopPost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: fistShop == null ? '' : JSON.stringify(fistShop), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 获取我们的门店列表，用户凭证从http header读取 
     * 
     * @param token 用户的登录凭证
     */
    public shopCarMobileMyshopGetWithHttpInfo(token: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/shop/carMobile/myshop`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'token' is not null or undefined
        if (token === null || token === undefined) {
            throw new Error('Required parameter token was null or undefined when calling shopCarMobileMyshopGet.');
        }
        headers.set('token', String(token));

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 查询某个门店 
     * 
     * @param shopId 门店id
     */
    public shopCarMobileShopIdGetWithHttpInfo(shopId: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/shop/carMobile/${shopId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'shopId' is not null or undefined
        if (shopId === null || shopId === undefined) {
            throw new Error('Required parameter shopId was null or undefined when calling shopCarMobileShopIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 修改门店信息 
     * 
     * @param payload 更新的门店对象
     */
    public shopCarMobileUpdatePostWithHttpInfo(payload: models.UpdateShopInfoObj, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/shop/carMobile/update`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'payload' is not null or undefined
        if (payload === null || payload === undefined) {
            throw new Error('Required parameter payload was null or undefined when calling shopCarMobileUpdatePost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: payload == null ? '' : JSON.stringify(payload), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
