/**
 * 天会智数微信模块 API
 * 前后端交互协议, 遵循以下约定:   1. 所有api都属于无状态接口   2. 除了/user/login,/_*_/sms,/user/register,/user/updatePwd接口，其他接口都要登录之后才能操作   3. 登录成功之后，后端每次都把tokenheader,回传服务端   4. 客户端请求参数分两种:       1. 以form方式提交，可以附带store、pageNumber、pageSize参数       2. 以json方式提交，务必附带store、pageNumber、pageSize属性，如果没有值，为null   5. 服务端返回统一的json， 格式如下:       {        meta:{         code: 状态码         link: 链接         limit: 每页多少条         total:  总共多少条         current: 当前页         method: 方法         parameters:          {            客户端的请求参数          startDate:开始时间          endDate:结束时间          ........:xxxx(请求参数都会在meta里面)                    },         store:          {           客户端专用，保存交互状态的对象         }        }        data:          {           保存的数据，可能是array, object          object          list<object>          jsonArray        }        error:{           code:xxxxx (子状态码)           message:xxxxx        }       }            6. 公共状态(meta->code)约定如下:              500:             服务端处理失败， 返回json中存在error, meta对象， 不一定存在data对象          200:             成功， 返回json中有meta， data对象， 不存在error对象          401:             认证失败，用户的token过期或者token错误， 客户端需要引导用户重新登录          403:             授权失败， 一般出现在用户访问没有权限的资源, 返回json中存在error, meta对象          400:             参数错误,  客户端提交的参数不正确, 返回json中存在error, meta对象                 7. error的子状态码， 开发人员可以自行约定              8. header头信息信息:1.token: token值, 2. channel: 值:2.1 carh5(汽后-H5),carpc(汽后-PC),bh5(大B-H5),bpc(大B-PC)   
 *
 * OpenAPI spec version: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class UserApi {
    protected basePath = '/manageredirect/api/v1/manage';
    // protected basePath = '/api/v1/manage';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * 子账户激活 
     * 
     * @param password 新密码
     * @param rePassword 确认密码
     */
    public userActivatePost(password: string, rePassword: string, extraHttpRequestParams?: any): Observable<models.CommonResponse> {
        return this.userActivatePostWithHttpInfo(password, rePassword, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 创建子账号, H5新增 
     * 
     * @param mobile 手机号，登录账号
     * @param shopId 可查看数据源，门店id，json串
     * @param password 子账号密码，明文形式；会用于发送手机短信
     * @param passwordMD5 子账号密码，前端加密；后端拿到后，会再次进行加密保存
     * @param name 账户使用者
     */
    public userCarMobileAccountCreatePost(mobile: string, shopId: string, password: string, passwordMD5: string, name?: string, extraHttpRequestParams?: any): Observable<models.CommonResponse> {
        return this.userCarMobileAccountCreatePostWithHttpInfo(mobile, shopId, password, passwordMD5, name, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 删除子账号, H5新增， 后端控制只有父账号能操作 
     * 
     * @param id 账号id
     */
    public userCarMobileAccountIdDeleteDelete(id: number, extraHttpRequestParams?: any): Observable<models.CommonResponse> {
        return this.userCarMobileAccountIdDeleteDeleteWithHttpInfo(id, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 获取子账号信息, H5新增， 后端控制只有父账号能操作 
     * 
     * @param id 账号id
     */
    public userCarMobileAccountIdGet(id: number, extraHttpRequestParams?: any): Observable<models.UserAccountResponse> {
        return this.userCarMobileAccountIdGetWithHttpInfo(id, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 修改子账号, H5新增 
     * 
     * @param id 子账号id
     * @param shopId 可查看数据源，关联门店id，用逗号分隔
     * @param name 账户使用者
     */
    public userCarMobileAccountUpdatePost(id: number, shopId: string, name?: string, extraHttpRequestParams?: any): Observable<models.CommonResponse> {
        return this.userCarMobileAccountUpdatePostWithHttpInfo(id, shopId, name, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 用户子账号列表，H5新增
     * 
     */
    public userCarMobileAccountsGet(extraHttpRequestParams?: any): Observable<models.UserAccountListResponse> {
        return this.userCarMobileAccountsGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 登录之后修改密码， 通过原密码修改 
     * 
     * @param oldPassword 旧密码
     * @param password 新密码
     * @param rePassword 确认密码
     */
    public userCarMobileChangePwdPost(oldPassword: string, password: string, rePassword: string, extraHttpRequestParams?: any): Observable<models.CommonResponse> {
        return this.userCarMobileChangePwdPostWithHttpInfo(oldPassword, password, rePassword, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 我的账户，H5修改，添加权限之后， 额外返回角色列表
     * 
     * @param token 用户的登录凭证
     */
    public userCarMobileMeGet(token: string, extraHttpRequestParams?: any): Observable<models.MeResponse> {
        return this.userCarMobileMeGetWithHttpInfo(token, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 用户登录
     * 用户通过手机号，密码，验证码登录车门店系统。返回结构的lastShopId是最近选中门店id,  登录之后要选中该门店, 2016-08 H5修改，添加返回角色和权限信息 
     * @param mobile 登录手机号
     * @param password 登录密码
     * @param code 验证码
     */
    public userLoginPost(mobile: string, password: string, code: string, extraHttpRequestParams?: any): Observable<models.UserLoginResponse> {
        return this.userLoginPostWithHttpInfo(mobile, password, code, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 用户登录
     * 注销登出， 删除token缓存， 数据库token设置为null 
     */
    public userLogoutPost(extraHttpRequestParams?: any): Observable<models.CommonResponse> {
        return this.userLogoutPostWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 发送找回密码验证码 
     * 
     * @param mobile 手机号
     * @param rnd 4位随机数， 客户端生成
     * @param code 验证码
     * @param sign 签名, md5(phone+rnd+salt)， 其中salt&#x3D;thzs0708， 不符合签名的请求一律返回错误
     */
    public userPasswordSmsPost(mobile: string, rnd: string, code: string, sign: string, extraHttpRequestParams?: any): Observable<models.CommonResponse> {
        return this.userPasswordSmsPostWithHttpInfo(mobile, rnd, code, sign, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 用户注册
     * 
     * @param mobile 手机号
     * @param password 密码
     * @param code 手机验证码
     * @param uuid 图形验证码uuid
     * @param captcha 图形验证码
     * @param registerChannal 注册渠道（pc为1，移动为2）；
     * @param type 用户类型(目前只能是汽修用户), 1普通用户, 2汽修用户, 3餐饮用户
     */
    public userRegisterPost(mobile: string, password: string, code: string, uuid: string, captcha: string, registerChannal: number, type: number, extraHttpRequestParams?: any): Observable<models.UserResponse> {
        return this.userRegisterPostWithHttpInfo(mobile, password, code, uuid, captcha, registerChannal, type, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 发送注册验证码， 注册验证码只能用在注册，后端放入reids，设置timeout，做单限制/单ip发送次数?
     * 
     * @param mobile 手机号
     * @param rnd 4位随机数， 客户端生成
     * @param code 验证码
     * @param sign 签名, md5(phone+rnd+salt)， 其中salt&#x3D;thzs0708, 不符合签名的请求一律返回错误
     */
    public userRegisterSmsPost(mobile: string, rnd: string, code: string, sign: string, extraHttpRequestParams?: any): Observable<models.CommonResponse> {
        return this.userRegisterSmsPostWithHttpInfo(mobile, rnd, code, sign, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 不用登录系统, 通过手机验证码验明身份后修改密码。 通过凭证去修改密码， 服务端要验证凭证可靠性，和手机号关联, 10分钟timeout 
     * 
     * @param password 密码
     * @param rePassword 确认密码
     * @param sign /common/code/verify返回的sign
     */
    public userUpdatePwdPost(password: string, rePassword: string, sign: string, extraHttpRequestParams?: any): Observable<models.UserResponse> {
        return this.userUpdatePwdPostWithHttpInfo(password, rePassword, sign, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 用户信息
     * 根据用户的token，获取用户的信息 
     * @param token 用户token
     */
    public userUserInfoTokenGet(token: string, extraHttpRequestParams?: any): Observable<models.UserInfoTokenResponse> {
        return this.userUserInfoTokenGetWithHttpInfo(token, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * 子账户激活 
     * 
     * @param password 新密码
     * @param rePassword 确认密码
     */
    public userActivatePostWithHttpInfo(password: string, rePassword: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/activate`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'password' is not null or undefined
        if (password === null || password === undefined) {
            throw new Error('Required parameter password was null or undefined when calling userActivatePost.');
        }
        // verify required parameter 'rePassword' is not null or undefined
        if (rePassword === null || rePassword === undefined) {
            throw new Error('Required parameter rePassword was null or undefined when calling userActivatePost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/x-www-form-urlencoded');

        if (password !== undefined) {
            formParams.set('password', <any>password);
        }

        if (rePassword !== undefined) {
            formParams.set('rePassword', <any>rePassword);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 创建子账号, H5新增 
     * 
     * @param mobile 手机号，登录账号
     * @param shopId 可查看数据源，门店id，json串
     * @param password 子账号密码，明文形式；会用于发送手机短信
     * @param passwordMD5 子账号密码，前端加密；后端拿到后，会再次进行加密保存
     * @param name 账户使用者
     */
    public userCarMobileAccountCreatePostWithHttpInfo(mobile: string, shopId: string, password: string, passwordMD5: string, name?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/carMobile/account/create`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'mobile' is not null or undefined
        if (mobile === null || mobile === undefined) {
            throw new Error('Required parameter mobile was null or undefined when calling userCarMobileAccountCreatePost.');
        }
        // verify required parameter 'shopId' is not null or undefined
        if (shopId === null || shopId === undefined) {
            throw new Error('Required parameter shopId was null or undefined when calling userCarMobileAccountCreatePost.');
        }
        // verify required parameter 'password' is not null or undefined
        if (password === null || password === undefined) {
            throw new Error('Required parameter password was null or undefined when calling userCarMobileAccountCreatePost.');
        }
        // verify required parameter 'passwordMD5' is not null or undefined
        if (passwordMD5 === null || passwordMD5 === undefined) {
            throw new Error('Required parameter passwordMD5 was null or undefined when calling userCarMobileAccountCreatePost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/x-www-form-urlencoded');

        if (name !== undefined) {
            formParams.set('name', <any>name);
        }

        if (mobile !== undefined) {
            formParams.set('mobile', <any>mobile);
        }

        if (shopId !== undefined) {
            formParams.set('shopId', <any>shopId);
        }

        if (password !== undefined) {
            formParams.set('password', <any>password);
        }

        if (passwordMD5 !== undefined) {
            formParams.set('passwordMD5', <any>passwordMD5);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 删除子账号, H5新增， 后端控制只有父账号能操作 
     * 
     * @param id 账号id
     */
    public userCarMobileAccountIdDeleteDeleteWithHttpInfo(id: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/carMobile/account/${id}/delete`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling userCarMobileAccountIdDeleteDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 获取子账号信息, H5新增， 后端控制只有父账号能操作 
     * 
     * @param id 账号id
     */
    public userCarMobileAccountIdGetWithHttpInfo(id: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/carMobile/account/${id}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling userCarMobileAccountIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 修改子账号, H5新增 
     * 
     * @param id 子账号id
     * @param shopId 可查看数据源，关联门店id，用逗号分隔
     * @param name 账户使用者
     */
    public userCarMobileAccountUpdatePostWithHttpInfo(id: number, shopId: string, name?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/carMobile/account/update`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling userCarMobileAccountUpdatePost.');
        }
        // verify required parameter 'shopId' is not null or undefined
        if (shopId === null || shopId === undefined) {
            throw new Error('Required parameter shopId was null or undefined when calling userCarMobileAccountUpdatePost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/x-www-form-urlencoded');

        if (id !== undefined) {
            formParams.set('id', <any>id);
        }

        if (name !== undefined) {
            formParams.set('name', <any>name);
        }

        if (shopId !== undefined) {
            formParams.set('shopId', <any>shopId);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 用户子账号列表，H5新增
     * 
     */
    public userCarMobileAccountsGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/carMobile/accounts`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 登录之后修改密码， 通过原密码修改 
     * 
     * @param oldPassword 旧密码
     * @param password 新密码
     * @param rePassword 确认密码
     */
    public userCarMobileChangePwdPostWithHttpInfo(oldPassword: string, password: string, rePassword: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/carMobile/changePwd`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'oldPassword' is not null or undefined
        if (oldPassword === null || oldPassword === undefined) {
            throw new Error('Required parameter oldPassword was null or undefined when calling userCarMobileChangePwdPost.');
        }
        // verify required parameter 'password' is not null or undefined
        if (password === null || password === undefined) {
            throw new Error('Required parameter password was null or undefined when calling userCarMobileChangePwdPost.');
        }
        // verify required parameter 'rePassword' is not null or undefined
        if (rePassword === null || rePassword === undefined) {
            throw new Error('Required parameter rePassword was null or undefined when calling userCarMobileChangePwdPost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/x-www-form-urlencoded');

        if (oldPassword !== undefined) {
            formParams.set('oldPassword', <any>oldPassword);
        }

        if (password !== undefined) {
            formParams.set('password', <any>password);
        }

        if (rePassword !== undefined) {
            formParams.set('rePassword', <any>rePassword);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 我的账户，H5修改，添加权限之后， 额外返回角色列表
     * 
     * @param token 用户的登录凭证
     */
    public userCarMobileMeGetWithHttpInfo(token: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/carMobile/me`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'token' is not null or undefined
        if (token === null || token === undefined) {
            throw new Error('Required parameter token was null or undefined when calling userCarMobileMeGet.');
        }
        headers.set('token', String(token));

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 用户登录
     * 用户通过手机号，密码，验证码登录车门店系统。返回结构的lastShopId是最近选中门店id,  登录之后要选中该门店, 2016-08 H5修改，添加返回角色和权限信息 
     * @param mobile 登录手机号
     * @param password 登录密码
     * @param code 验证码
     */
    public userLoginPostWithHttpInfo(mobile: string, password: string, code: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/login`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'mobile' is not null or undefined
        if (mobile === null || mobile === undefined) {
            throw new Error('Required parameter mobile was null or undefined when calling userLoginPost.');
        }
        // verify required parameter 'password' is not null or undefined
        if (password === null || password === undefined) {
            throw new Error('Required parameter password was null or undefined when calling userLoginPost.');
        }
        // verify required parameter 'code' is not null or undefined
        if (code === null || code === undefined) {
            throw new Error('Required parameter code was null or undefined when calling userLoginPost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/x-www-form-urlencoded');

        if (mobile !== undefined) {
            formParams.set('mobile', <any>mobile);
        }

        if (password !== undefined) {
            formParams.set('password', <any>password);
        }

        if (code !== undefined) {
            formParams.set('code', <any>code);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 用户登录
     * 注销登出， 删除token缓存， 数据库token设置为null 
     */
    public userLogoutPostWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/logout`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 发送找回密码验证码 
     * 
     * @param mobile 手机号
     * @param rnd 4位随机数， 客户端生成
     * @param code 验证码
     * @param sign 签名, md5(phone+rnd+salt)， 其中salt&#x3D;thzs0708， 不符合签名的请求一律返回错误
     */
    public userPasswordSmsPostWithHttpInfo(mobile: string, rnd: string, code: string, sign: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/password/sms`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'mobile' is not null or undefined
        if (mobile === null || mobile === undefined) {
            throw new Error('Required parameter mobile was null or undefined when calling userPasswordSmsPost.');
        }
        // verify required parameter 'rnd' is not null or undefined
        if (rnd === null || rnd === undefined) {
            throw new Error('Required parameter rnd was null or undefined when calling userPasswordSmsPost.');
        }
        // verify required parameter 'code' is not null or undefined
        if (code === null || code === undefined) {
            throw new Error('Required parameter code was null or undefined when calling userPasswordSmsPost.');
        }
        // verify required parameter 'sign' is not null or undefined
        if (sign === null || sign === undefined) {
            throw new Error('Required parameter sign was null or undefined when calling userPasswordSmsPost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/x-www-form-urlencoded');

        if (mobile !== undefined) {
            formParams.set('mobile', <any>mobile);
        }

        if (rnd !== undefined) {
            formParams.set('rnd', <any>rnd);
        }

        if (code !== undefined) {
            formParams.set('code', <any>code);
        }

        if (sign !== undefined) {
            formParams.set('sign', <any>sign);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 用户注册
     * 
     * @param mobile 手机号
     * @param password 密码
     * @param code 手机验证码
     * @param uuid 图形验证码uuid
     * @param captcha 图形验证码
     * @param registerChannal 注册渠道（pc为1，移动为2）；
     * @param type 用户类型(目前只能是汽修用户), 1普通用户, 2汽修用户, 3餐饮用户
     */
    public userRegisterPostWithHttpInfo(mobile: string, password: string, code: string, uuid: string, captcha: string, registerChannal: number, type: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/register`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'mobile' is not null or undefined
        if (mobile === null || mobile === undefined) {
            throw new Error('Required parameter mobile was null or undefined when calling userRegisterPost.');
        }
        // verify required parameter 'password' is not null or undefined
        if (password === null || password === undefined) {
            throw new Error('Required parameter password was null or undefined when calling userRegisterPost.');
        }
        // verify required parameter 'code' is not null or undefined
        if (code === null || code === undefined) {
            throw new Error('Required parameter code was null or undefined when calling userRegisterPost.');
        }
        // verify required parameter 'uuid' is not null or undefined
        if (uuid === null || uuid === undefined) {
            throw new Error('Required parameter uuid was null or undefined when calling userRegisterPost.');
        }
        // verify required parameter 'captcha' is not null or undefined
        if (captcha === null || captcha === undefined) {
            throw new Error('Required parameter captcha was null or undefined when calling userRegisterPost.');
        }
        // verify required parameter 'registerChannal' is not null or undefined
        if (registerChannal === null || registerChannal === undefined) {
            throw new Error('Required parameter registerChannal was null or undefined when calling userRegisterPost.');
        }
        // verify required parameter 'type' is not null or undefined
        if (type === null || type === undefined) {
            throw new Error('Required parameter type was null or undefined when calling userRegisterPost.');
        }
        headers.set('uuid', String(uuid));

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/x-www-form-urlencoded');

        if (mobile !== undefined) {
            formParams.set('mobile', <any>mobile);
        }

        if (password !== undefined) {
            formParams.set('password', <any>password);
        }

        if (code !== undefined) {
            formParams.set('code', <any>code);
        }

        if (captcha !== undefined) {
            formParams.set('captcha', <any>captcha);
        }

        if (registerChannal !== undefined) {
            formParams.set('registerChannal', <any>registerChannal);
        }

        if (type !== undefined) {
            formParams.set('type', <any>type);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 发送注册验证码， 注册验证码只能用在注册，后端放入reids，设置timeout，做单限制/单ip发送次数?
     * 
     * @param mobile 手机号
     * @param rnd 4位随机数， 客户端生成
     * @param code 验证码
     * @param sign 签名, md5(phone+rnd+salt)， 其中salt&#x3D;thzs0708, 不符合签名的请求一律返回错误
     */
    public userRegisterSmsPostWithHttpInfo(mobile: string, rnd: string, code: string, sign: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/register/sms`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'mobile' is not null or undefined
        if (mobile === null || mobile === undefined) {
            throw new Error('Required parameter mobile was null or undefined when calling userRegisterSmsPost.');
        }
        // verify required parameter 'rnd' is not null or undefined
        if (rnd === null || rnd === undefined) {
            throw new Error('Required parameter rnd was null or undefined when calling userRegisterSmsPost.');
        }
        // verify required parameter 'code' is not null or undefined
        if (code === null || code === undefined) {
            throw new Error('Required parameter code was null or undefined when calling userRegisterSmsPost.');
        }
        // verify required parameter 'sign' is not null or undefined
        if (sign === null || sign === undefined) {
            throw new Error('Required parameter sign was null or undefined when calling userRegisterSmsPost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/x-www-form-urlencoded');

        if (mobile !== undefined) {
            formParams.set('mobile', <any>mobile);
        }

        if (rnd !== undefined) {
            formParams.set('rnd', <any>rnd);
        }

        if (code !== undefined) {
            formParams.set('code', <any>code);
        }

        if (sign !== undefined) {
            formParams.set('sign', <any>sign);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 不用登录系统, 通过手机验证码验明身份后修改密码。 通过凭证去修改密码， 服务端要验证凭证可靠性，和手机号关联, 10分钟timeout 
     * 
     * @param password 密码
     * @param rePassword 确认密码
     * @param sign /common/code/verify返回的sign
     */
    public userUpdatePwdPostWithHttpInfo(password: string, rePassword: string, sign: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/updatePwd`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'password' is not null or undefined
        if (password === null || password === undefined) {
            throw new Error('Required parameter password was null or undefined when calling userUpdatePwdPost.');
        }
        // verify required parameter 'rePassword' is not null or undefined
        if (rePassword === null || rePassword === undefined) {
            throw new Error('Required parameter rePassword was null or undefined when calling userUpdatePwdPost.');
        }
        // verify required parameter 'sign' is not null or undefined
        if (sign === null || sign === undefined) {
            throw new Error('Required parameter sign was null or undefined when calling userUpdatePwdPost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/x-www-form-urlencoded');

        if (password !== undefined) {
            formParams.set('password', <any>password);
        }

        if (rePassword !== undefined) {
            formParams.set('rePassword', <any>rePassword);
        }

        if (sign !== undefined) {
            formParams.set('sign', <any>sign);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 用户信息
     * 根据用户的token，获取用户的信息 
     * @param token 用户token
     */
    public userUserInfoTokenGetWithHttpInfo(token: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/userInfo/${token}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'token' is not null or undefined
        if (token === null || token === undefined) {
            throw new Error('Required parameter token was null or undefined when calling userUserInfoTokenGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
